#!/usr/bin/env python
# -*- coding:utf-8 -*-


# ############################################################################
#  license :
# ============================================================================
#
#  File :        fbelt.py
#
#  Project :     DimTel FBE-LTE controller
#
# This file is part of Tango device class.
# 
# Tango is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Tango is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Tango.  If not, see <http://www.gnu.org/licenses/>.
# 
#
#  $Author :      stefano.cleva$
#
#  $Revision :    $
#
#  $Date :        $
#
#  $HeadUrl :     $
# ============================================================================
#            This file is generated by POGO
#     (Program Obviously used to Generate tango Object)
# ############################################################################

__all__ = ["fbelt", "fbeltClass", "main"]

__docformat__ = 'restructuredtext'

import PyTango
import sys
# Add additional import
#----- PROTECTED REGION ID(fbelt.additionnal_import) ENABLED START -----#

import DimFBEinterf
import phaseFitter

#----- PROTECTED REGION END -----#	//	fbelt.additionnal_import

# Device States Description
# ON : 
# MOVING : 
# FAULT : 


class fbelt (PyTango.Device_4Impl):
    """DimTel FBE-LTE controller"""
    
    # -------- Add you global variables here --------------------------
    #----- PROTECTED REGION ID(fbelt.global_variables) ENABLED START -----#


    interpdat = []

    def CheckAttdB(self, a):	
    	val = a * 2
    	check = int(val)
    	diff = abs(check - val)
    	if (diff != 0.0):
	# self.set_status('Att Out Of Range')
		return -1	

    	if (not((0 <= check) and (check <= 63))):
   	# self.set_status('Att Out Of Range')
		return -2
    
    	return check

    def BuildConvTab(self):
	global interpdat
	interpdat = phaseFitter.interpol()

    def RDBstuffI(self, a,b,c):
        #print('RDBstuffI: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'X' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.attr_ID_read = c
		self.set_state(PyTango.DevState.ON)
		self.set_status('Get ID OK')
	
    def RDBstuffHP(self, a,b,c):
        #print('RDBstuffHP: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'pha:OK' in c:
		self.attr_HorizontalPhase_read = self.SetHP	
		self.set_state(PyTango.DevState.ON)	
		self.set_status('Hor Phase Set OK')
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('Hor Phase Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffHPDeg(self, a,b,c):
        #print('RDBstuffHPDeg: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	self.set_status(a)
	if 'pha:OK' in c:
		self.attr_HorizontalPhase_read = self.SetHP
		self.attr_HorizontalPhaseDeg_read = self.SetHPDeg
		self.set_status('Hor Phase Set OK')
		self.set_state(PyTango.DevState.ON)
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('Hor Phase Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffVP(self, a,b,c):
        #print('RDBstuffVP: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'pha:OK' in c:
		self.attr_VerticalPhase_read = self.SetVP
		self.set_status('Ver Phase Set OK')
		self.set_state(PyTango.DevState.ON)
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('Ver Phase Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffVPDeg(self, a,b,c):
        #print('RDBstuffVPDeg: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	self.set_status(a)
	if 'pha:OK' in c:
		self.attr_VerticalPhase_read = self.SetVP
		self.attr_VerticalPhaseDeg_read = self.SetVPDeg
		self.set_status('Ver Phase Set OK')
		self.set_state(PyTango.DevState.ON)
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('Ver Phase Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffLP(self, a,b,c):
        #print('RDBstuffLP: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'pha:OK' in c:
		self.attr_LongitudinalPhase_read = self.SetLP
		self.set_state(PyTango.DevState.ON)
		self.set_status('Long Phase Set OK')
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('Long Phase Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffLPDeg(self, a,b,c):
        #print('RDBstuffLPDeg: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	self.set_status(a)
	if 'pha:OK' in c:
		self.attr_LongitudinalPhase_read = self.SetLP
		self.attr_LongitudinalPhaseDeg_read = self.SetLPDeg
		self.set_status('Long Phase Set OK')
		self.set_state(PyTango.DevState.ON)
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('Long Phase Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffBEP(self, a,b,c):
        #print('RDBstuffBEP: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'pha:OK' in c:
		self.attr_BackEndPhase_read = self.SetBEP
		self.set_state(PyTango.DevState.ON)
		self.set_status('BE Phase Set OK')
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('BE Phase Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffBEPDeg(self, a,b,c):
        #print('RDBstuffBEPDeg: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	self.set_status(a)
	if 'pha:OK' in c:
		self.attr_BackEndPhase_read = self.SetBEP
		self.attr_BackEndPhaseDeg_read = self.SetBEPDeg
		self.set_status('BE Set Phase OK')
		self.set_state(PyTango.DevState.ON)
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('BE Phase Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffHAdB(self, a,b,c):
        #print('RDBstuffHA_dB: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'att:OK' in c:
		self.attr_HorizontalAttenuation_read = self.SetHA
		self.attr_HorizontalAttenuation_dB_read = self.SetHAdB
		self.set_status('Hor Atten dB OK')
		self.set_state(PyTango.DevState.ON)
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('Hor Atten dB Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffHA(self, a,b,c):
        #print('RDBstuffHA-TI: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'att:OK' in c:
		self.attr_HorizontalAttenuation_read = self.SetHA		
		self.set_status('Hor Atten OK')
		self.set_state(PyTango.DevState.ON)
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('Hor Atten Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffVAdB(self, a,b,c):
        #print('RDBstuffVA_dB: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'att:OK' in c:
		self.attr_VerticalAttenuation_read = self.SetVA
		self.attr_VerticalAttenuation_dB_read = self.SetVAdB
		self.set_status('Ver Atten dB OK')
		self.set_state(PyTango.DevState.ON)
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('Ver Atten dB Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffVA(self, a,b,c):
        #print('RDBstuffVA-TI: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'att:OK' in c:
		self.attr_VerticalAttenuation_read = self.SetVA
		self.set_status('Ver Atten OK')
		self.set_state(PyTango.DevState.ON)
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('Ver Atten Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffLAdB(self, a,b,c):
        #print('RDBstuffLA_dB: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'att:OK' in c:
		self.attr_LongitudinalAttenuation_read = self.SetLA
		self.attr_LongitudinalAttenuation_dB_read = self.SetLAdB
		self.set_status('Long Atten dB OK')
		self.set_state(PyTango.DevState.ON)
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('Long Atten dB Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffLA(self, a,b,c):
        #print('RDBstuffLA-TI: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'att:OK' in c:
		self.attr_LongitudinalAttenuation_read = self.SetLA
		self.set_status('Long Atten OK')
		self.set_state(PyTango.DevState.ON)
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('Long Atten Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffBEAdB(self, a,b,c):
        #print('RDBstuffBEA_dB: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'att:OK' in c:
		self.attr_BackEndAttenuation_read = self.SetBEA
		self.attr_BackEndAttenuation_dB_read = self.SetBEAdB
		self.set_status('BE Atten dB OK')
		self.set_state(PyTango.DevState.ON)
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('BE Atten dB Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffBEA(self, a,b,c):
        #print('RDBstuffBEA-TI: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if 'att:OK' in c:
		self.attr_BackEndAttenuation_read = self.SetBEA
		self.set_state(PyTango.DevState.ON)
		self.set_status('BE Atten OK')
	elif '*' in c:
		self.set_state(PyTango.DevState.MOVING)
		self.set_status('')
	elif 'X' in c:
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
	elif '@' in c:
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
	else:
		self.set_status('BE Atten Out Of Range')
		self.set_state(PyTango.DevState.ALARM)

    def RDBstuffT(self, a,b,c):
        #print('RDBstuffT: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if (c == 'X'):
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
		return
	if (c == '@'):
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
		return
	if ((a == '*') and (b == '*')):
		self.attr_Temperature_read = c
		self.set_status('TempMeasCompleted')
		self.set_state(PyTango.DevState.ON)

    def RDBstuffR(self, a,b,c):
        #print('RDBstuffR: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if (c == 'X'):
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
		return
	if (c == '@'):
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
		return
	self.attr_RPM_read = c
	self.set_state(PyTango.DevState.ON)
	self.set_status('RPM OK')
        
    def PassThrough(self, val):
        return val

    def ScaleTemp(self, val):
        tempval = float(val)
        tempval = tempval/16
        return tempval

    def ScaleRPM(self, val):
        tempval = float(val)
        tempval = tempval * 30
	return int(tempval)

    def RDBstuffOWid(self, a,b,c):
        #print('RDBstuffOW: %s %s %s' %(a, b, c))
	self.error = a
	self.status = b
	if (c == 'X'):
		self.set_status(a)
		self.set_state(PyTango.DevState.FAULT)
		return
	if (c == '@'):
		self.set_status(a)	
		self.set_state(PyTango.DevState.MOVING)
		return

	self.attr_OneWireID_read = c #eg: '2493130903606263845'
	self.set_state(PyTango.DevState.ON)
	self.set_status('Get OW OK')

   
    #----- PROTECTED REGION END -----#	//	fbelt.global_variables

    def __init__(self, cl, name):
        PyTango.Device_4Impl.__init__(self,cl,name)
        self.debug_stream("In __init__()")
        fbelt.init_device(self)
        #----- PROTECTED REGION ID(fbelt.__init__) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	fbelt.__init__
        
    def delete_device(self):
        self.debug_stream("In delete_device()")
        #----- PROTECTED REGION ID(fbelt.delete_device) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	fbelt.delete_device

    def init_device(self):
        self.debug_stream("In init_device()")
        self.get_device_properties(self.get_device_class())
        self.attr_Temperature_read = 0.0
        self.attr_RPM_read = 0
        self.attr_ID_read = ""
        self.attr_HorizontalPhase_read = 0
        self.attr_VerticalPhase_read = 0
        self.attr_LongitudinalPhase_read = 0
        self.attr_BackEndPhase_read = 0
        self.attr_HorizontalAttenuation_read = 0
        self.attr_VerticalAttenuation_read = 0
        self.attr_LongitudinalAttenuation_read = 0
        self.attr_BackEndAttenuation_read = 0
        self.attr_IP_read = ""
        self.attr_Port_read = ""
        self.attr_HorizontalPhaseDeg_read = 0
        self.attr_VerticalPhaseDeg_read = 0
        self.attr_LongitudinalPhaseDeg_read = 0
        self.attr_BackEndPhaseDeg_read = 0
        self.attr_OneWireID_read = ""
        self.attr_HorizontalAttenuation_dB_read = 0.0
        self.attr_VerticalAttenuation_dB_read = 0.0
        self.attr_BackEndAttenuation_dB_read = 0.0
        self.attr_LongitudinalAttenuation_dB_read = 0.0
        #----- PROTECTED REGION ID(fbelt.init_device) ENABLED START -----#
	self.BuildConvTab()
        self.attr_Temperature_read = '---'
        self.attr_RPM_read = '---'
        self.attr_ID_read = '---'
	self.value = ''
        self.error = ''
        self.status = ''
	self.SetHP = 0
	self.SetVP = 0
	self.SetLP = 0
	self.SetBEP = 0
	self.SetHPDeg = 0
	self.SetVPDeg = 0
	self.SetLPDeg = 0
	self.SetBEPDeg = 0
	self.SetHA = 0
	self.SetVA = 0
	self.SetLA = 0
	self.SetBEA = 0
	self.SetHAdB = 0
	self.SetVAdB = 0
	self.SetLAdB = 0
	self.SetBEAdB = 0

	#print self.device_property_list
	#print self.device_property_list['DeviceIP']
	#print self.device_property_list['DevicePort']
	
	self.IP = self.device_property_list['DeviceIP'][2]
	self.Port = self.device_property_list['DevicePort'][2]
        self.attr_IP_read = self.IP
	self.attr_Port_read = self.Port
	self.set_status('Init Completed')
	self.set_state(PyTango.DevState.ON)

        #----- PROTECTED REGION END -----#	//	fbelt.init_device

    def always_executed_hook(self):
        self.debug_stream("In always_excuted_hook()")
        #----- PROTECTED REGION ID(fbelt.always_executed_hook) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	fbelt.always_executed_hook

    # -------------------------------------------------------------------------
    #    fbelt read/write attribute methods
    # -------------------------------------------------------------------------
    
    def read_Temperature(self, attr):
        self.debug_stream("In read_Temperature()")
        #----- PROTECTED REGION ID(fbelt.Temperature_read) ENABLED START -----#
        attr.set_value(self.attr_Temperature_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.Temperature_read
        
    def read_RPM(self, attr):
        self.debug_stream("In read_RPM()")
        #----- PROTECTED REGION ID(fbelt.RPM_read) ENABLED START -----#
        attr.set_value(self.attr_RPM_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.RPM_read
        
    def read_ID(self, attr):
        self.debug_stream("In read_ID()")
        #----- PROTECTED REGION ID(fbelt.ID_read) ENABLED START -----#
        attr.set_value(self.attr_ID_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.ID_read
        
    def read_HorizontalPhase(self, attr):
        self.debug_stream("In read_HorizontalPhase()")
        #----- PROTECTED REGION ID(fbelt.HorizontalPhase_read) ENABLED START -----#
        attr.set_value(self.attr_HorizontalPhase_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.HorizontalPhase_read
        
    def write_HorizontalPhase(self, attr):
        self.debug_stream("In write_HorizontalPhase()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.HorizontalPhase_write) ENABLED START -----#
        message = 'PHA:F:' + str(data) +'\r'
	self.SetHP = data
	DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffHP)
        
        #----- PROTECTED REGION END -----#	//	fbelt.HorizontalPhase_write
        
    def read_VerticalPhase(self, attr):
        self.debug_stream("In read_VerticalPhase()")
        #----- PROTECTED REGION ID(fbelt.VerticalPhase_read) ENABLED START -----#
        attr.set_value(self.attr_VerticalPhase_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.VerticalPhase_read
        
    def write_VerticalPhase(self, attr):
        self.debug_stream("In write_VerticalPhase()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.VerticalPhase_write) ENABLED START -----#
        message = 'PHA:G:' + str(data) +'\r'
	self.SetVP = data
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffVP)
        #----- PROTECTED REGION END -----#	//	fbelt.VerticalPhase_write
        
    def read_LongitudinalPhase(self, attr):
        self.debug_stream("In read_LongitudinalPhase()")
        #----- PROTECTED REGION ID(fbelt.LongitudinalPhase_read) ENABLED START -----#
        attr.set_value(self.attr_LongitudinalPhase_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.LongitudinalPhase_read
        
    def write_LongitudinalPhase(self, attr):
        self.debug_stream("In write_LongitudinalPhase()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.LongitudinalPhase_write) ENABLED START -----#
        message = 'PHA:H:' + str(data) +'\r'
	self.SetLP = data
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffLP)
        #----- PROTECTED REGION END -----#	//	fbelt.LongitudinalPhase_write
        
    def read_BackEndPhase(self, attr):
        self.debug_stream("In read_BackEndPhase()")
        #----- PROTECTED REGION ID(fbelt.BackEndPhase_read) ENABLED START -----#
        attr.set_value(self.attr_BackEndPhase_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.BackEndPhase_read
        
    def write_BackEndPhase(self, attr):
        self.debug_stream("In write_BackEndPhase()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.BackEndPhase_write) ENABLED START -----#
        message = 'PHA:E:' + str(data) +'\r'
	self.SetBEP = data
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffBEP)
        #----- PROTECTED REGION END -----#	//	fbelt.BackEndPhase_write
        
    def read_HorizontalAttenuation(self, attr):
        self.debug_stream("In read_HorizontalAttenuation()")
        #----- PROTECTED REGION ID(fbelt.HorizontalAttenuation_read) ENABLED START -----#
        attr.set_value(self.attr_HorizontalAttenuation_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.HorizontalAttenuation_read
        
    def write_HorizontalAttenuation(self, attr):
        self.debug_stream("In write_HorizontalAttenuation()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.HorizontalAttenuation_write) ENABLED START -----#
        message = 'ATT:H:' + str(data) +'\r'
	self.SetHA = data
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffHA)
        #----- PROTECTED REGION END -----#	//	fbelt.HorizontalAttenuation_write
        
    def read_VerticalAttenuation(self, attr):
        self.debug_stream("In read_VerticalAttenuation()")
        #----- PROTECTED REGION ID(fbelt.VerticalAttenuation_read) ENABLED START -----#
        attr.set_value(self.attr_VerticalAttenuation_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.VerticalAttenuation_read
        
    def write_VerticalAttenuation(self, attr):
        self.debug_stream("In write_VerticalAttenuation()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.VerticalAttenuation_write) ENABLED START -----#
        message = 'ATT:V:' + str(data) +'\r'
	self.SetVA = data
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffVA)   
        #----- PROTECTED REGION END -----#	//	fbelt.VerticalAttenuation_write
        
    def read_LongitudinalAttenuation(self, attr):
        self.debug_stream("In read_LongitudinalAttenuation()")
        #----- PROTECTED REGION ID(fbelt.LongitudinalAttenuation_read) ENABLED START -----#
        attr.set_value(self.attr_LongitudinalAttenuation_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.LongitudinalAttenuation_readviry
        
    def write_LongitudinalAttenuation(self, attr):
        self.debug_stream("In write_LongitudinalAttenuation()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.LongitudinalAttenuation_write) ENABLED START -----#
        message = 'ATT:L:' + str(data) +'\r'
	self.SetLA = data
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffLA)        
        #----- PROTECTED REGION END -----#	//	fbelt.LongitudinalAttenuation_write
        
    def read_BackEndAttenuation(self, attr):
        self.debug_stream("In read_BackEndAttenuation()")
        #----- PROTECTED REGION ID(fbelt.BackEndAttenuation_read) ENABLED START -----#
        attr.set_value(self.attr_BackEndAttenuation_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.BackEndAttenuation_read
        
    def write_BackEndAttenuation(self, attr):
        self.debug_stream("In write_BackEndAttenuation()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.BackEndAttenuation_write) ENABLED START -----#
        message = 'ATT:B:' + str(data) +'\r'
	self.SetBEA = data
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffBEA)        
        #----- PROTECTED REGION END -----#	//	fbelt.BackEndAttenuation_write
        
    def read_IP(self, attr):
        self.debug_stream("In read_IP()")
        #----- PROTECTED REGION ID(fbelt.IP_read) ENABLED START -----#
        attr.set_value(self.attr_IP_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.IP_read
        
    def read_Port(self, attr):
        self.debug_stream("In read_Port()")
        #----- PROTECTED REGION ID(fbelt.Port_read) ENABLED START -----#
        attr.set_value(self.attr_Port_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.Port_read
        
    def read_HorizontalPhaseDeg(self, attr):
        self.debug_stream("In read_HorizontalPhaseDeg()")
        #----- PROTECTED REGION ID(fbelt.HorizontalPhaseDeg_read) ENABLED START -----#
        attr.set_value(self.attr_HorizontalPhaseDeg_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.HorizontalPhaseDeg_read
        
    def write_HorizontalPhaseDeg(self, attr):
        self.debug_stream("In write_HorizontalPhaseDeg()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.HorizontalPhaseDeg_write) ENABLED START -----#
	
	val = phaseFitter.DegToDigit(data, interpdat)
	if val < 0:
		self.set_status('HorizontalPhaseDeg Out Of Range')
		self.set_state(PyTango.DevState.ALARM)
		return

	self.SetHPDeg = data
	self.SetHP = val
        message = 'PHA:F:' + str(val) +'\r'
	DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffHPDeg)
       
        #----- PROTECTED REGION END -----#	//	fbelt.HorizontalPhaseDeg_write
        
    def read_VerticalPhaseDeg(self, attr):
        self.debug_stream("In read_VerticalPhaseDeg()")
        #----- PROTECTED REGION ID(fbelt.VerticalPhaseDeg_read) ENABLED START -----#
        attr.set_value(self.attr_VerticalPhaseDeg_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.VerticalPhaseDeg_read
        
    def write_VerticalPhaseDeg(self, attr):
        self.debug_stream("In write_VerticalPhaseDeg()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.VerticalPhaseDeg_write) ENABLED START -----#

	val = phaseFitter.DegToDigit(data, interpdat)
	if val < 0:
		self.set_status('VerticalPhaseDeg Out Of Range')
		self.set_state(PyTango.DevState.ALARM)
		return

	self.SetVPDeg = data
	self.SetVP = val
        message = 'PHA:G:' + str(val) +'\r'
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffVPDeg)
        
        #----- PROTECTED REGION END -----#	//	fbelt.VerticalPhaseDeg_write
        
    def read_LongitudinalPhaseDeg(self, attr):
        self.debug_stream("In read_LongitudinalPhaseDeg()")
        #----- PROTECTED REGION ID(fbelt.LongitudinalPhaseDeg_read) ENABLED START -----#
        attr.set_value(self.attr_LongitudinalPhaseDeg_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.LongitudinalPhaseDeg_read
        
    def write_LongitudinalPhaseDeg(self, attr):
        self.debug_stream("In write_LongitudinalPhaseDeg()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.LongitudinalPhaseDeg_write) ENABLED START -----#

	val = phaseFitter.DegToDigit(data, interpdat)
	if val < 0:
		self.set_status('LongitudinalPhaseDeg Out Of Range')
		self.set_state(PyTango.DevState.ALARM)
		return

	self.SetLPDeg = data
	self.SetLP = val
        message = 'PHA:H:' + str(val) +'\r'
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffLPDeg)
        
        #----- PROTECTED REGION END -----#	//	fbelt.LongitudinalPhaseDeg_write
        
    def read_BackEndPhaseDeg(self, attr):
        self.debug_stream("In read_BackEndPhaseDeg()")
        #----- PROTECTED REGION ID(fbelt.BackEndPhaseDeg_read) ENABLED START -----#
        attr.set_value(self.attr_BackEndPhaseDeg_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.BackEndPhaseDeg_read
        
    def write_BackEndPhaseDeg(self, attr):
        self.debug_stream("In write_BackEndPhaseDeg()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.BackEndPhaseDeg_write) ENABLED START -----#

	val = phaseFitter.DegToDigit(data, interpdat)
	if val < 0:
		self.set_status('BackEndPhaseDeg Out Of Range')
		self.set_state(PyTango.DevState.ALARM)
		return

	self.SetBEPDeg = data
	self.SetBEP = val
        message = 'PHA:E:' + str(val) +'\r'
	DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffBEPDeg)
        
        #----- PROTECTED REGION END -----#	//	fbelt.BackEndPhaseDeg_write
        
    def read_OneWireID(self, attr):
        self.debug_stream("In read_OneWireID()")
        #----- PROTECTED REGION ID(fbelt.OneWireID_read) ENABLED START -----#
        attr.set_value(self.attr_OneWireID_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.OneWireID_read
        
    def read_HorizontalAttenuation_dB(self, attr):
        self.debug_stream("In read_HorizontalAttenuation_dB()")
        #----- PROTECTED REGION ID(fbelt.HorizontalAttenuation_dB_read) ENABLED START -----#
        attr.set_value(self.attr_HorizontalAttenuation_dB_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.HorizontalAttenuation_dB_read
        
    def write_HorizontalAttenuation_dB(self, attr):
        self.debug_stream("In write_HorizontalAttenuation_dB()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.HorizontalAttenuation_dB_write) ENABLED START -----#
        
	sv = self.CheckAttdB(data)
	if sv < 0:
		self.set_status('Hor att Out Of Range')
		self.set_state(PyTango.DevState.ALARM)
		return

	message = 'ATT:H:' + str(sv) +'\r'
	self.SetHAdB = data
	self.SetHA = sv
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffHAdB)
	
        #----- PROTECTED REGION END -----#	//	fbelt.HorizontalAttenuation_dB_write
        
    def read_VerticalAttenuation_dB(self, attr):
        self.debug_stream("In read_VerticalAttenuation_dB()")
        #----- PROTECTED REGION ID(fbelt.VerticalAttenuation_dB_read) ENABLED START -----#
        attr.set_value(self.attr_VerticalAttenuation_dB_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.VerticalAttenuation_dB_read
        
    def write_VerticalAttenuation_dB(self, attr):
        self.debug_stream("In write_VerticalAttenuation_dB()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.VerticalAttenuation_dB_write) ENABLED START -----#

	sv = self.CheckAttdB(data)
	if sv < 0:
		self.set_status('Ver att Out Of Range')
		self.set_state(PyTango.DevState.ALARM)
		return

        message = 'ATT:V:' + str(sv) +'\r'
	self.SetVAdB = data
	self.SetVA = sv
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffVAdB)   
        
        #----- PROTECTED REGION END -----#	//	fbelt.VerticalAttenuation_dB_write
        
    def read_BackEndAttenuation_dB(self, attr):
        self.debug_stream("In read_BackEndAttenuation_dB()")
        #----- PROTECTED REGION ID(fbelt.BackEndAttenuation_dB_read) ENABLED START -----#
        attr.set_value(self.attr_BackEndAttenuation_dB_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.BackEndAttenuation_dB_read
        
    def write_BackEndAttenuation_dB(self, attr):
        self.debug_stream("In write_BackEndAttenuation_dB()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.BackEndAttenuation_dB_write) ENABLED START -----#

	sv = self.CheckAttdB(data)
	if sv < 0:
		self.set_status('BE att Out Of Range')
		self.set_state(PyTango.DevState.ALARM)
		return

        message = 'ATT:B:' + str(sv) +'\r'
	self.SetBEA = sv
	self.SetBEAdB = data
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffBEAdB) 
        
        #----- PROTECTED REGION END -----#	//	fbelt.BackEndAttenuation_dB_write
        
    def read_LongitudinalAttenuation_dB(self, attr):
        self.debug_stream("In read_LongitudinalAttenuation_dB()")
        #----- PROTECTED REGION ID(fbelt.LongitudinalAttenuation_dB_read) ENABLED START -----#
        attr.set_value(self.attr_LongitudinalAttenuation_dB_read)
        
        #----- PROTECTED REGION END -----#	//	fbelt.LongitudinalAttenuation_dB_read
        
    def write_LongitudinalAttenuation_dB(self, attr):
        self.debug_stream("In write_LongitudinalAttenuation_dB()")
        data = attr.get_write_value()
        #----- PROTECTED REGION ID(fbelt.LongitudinalAttenuation_dB_write) ENABLED START -----#

	sv = self.CheckAttdB(data)
	if sv < 0:
		self.set_status('Long att Out Of Range')
		self.set_state(PyTango.DevState.ALARM)
		return

        message = 'ATT:L:' + str(sv) +'\r'
	self.SetLA = sv
	self.SetLAdB = data
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffLAdB)        
        
        #----- PROTECTED REGION END -----#	//	fbelt.LongitudinalAttenuation_dB_write  
        
    
    
            
    def read_attr_hardware(self, data):
        self.debug_stream("In read_attr_hardware()")
        #----- PROTECTED REGION ID(fbelt.read_attr_hardware) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	fbelt.read_attr_hardware


    # -------------------------------------------------------------------------
    #    fbelt command methods
    # -------------------------------------------------------------------------
    
    def GetID(self):
        """ *idn?
        :rtype: PyTango.DevString
        """
        self.debug_stream("In GetID()")
        argout = ""
        #----- PROTECTED REGION ID(fbelt.GetID) ENABLED START -----#
	
        message = '*IDN?' +'\r'
	#print(sys.version)	
	DimFBEinterf.Test(message)		
	DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffI)	
        
        #----- PROTECTED REGION END -----#	//	fbelt.GetID
        return argout
        
    def GetTemperature(self):
        """ GetTemperature
        :rtype: PyTango.DevFloat
        """
        self.debug_stream("In GetTemperature()")
        argout = 0.0
        #----- PROTECTED REGION ID(fbelt.GetTemperature) ENABLED START -----#
	self.set_status('TempMeasStarted')
	self.set_state(PyTango.DevState.MOVING)
	message = 'temp?' +'\r'
    		
	DimFBEinterf.SendAndGetT([message, 'ReadTempStarted', '*'], [self.IP, self.Port], self.ScaleTemp, self.RDBstuffT)
	
	        
        #----- PROTECTED REGION END -----#	//	fbelt.GetTemperature
        return argout
        
    def GetRPM(self):
        """ GetRPM
        :rtype: PyTango.DevLong
        """
        self.debug_stream("In GetRPM()")
        argout = 0
        #----- PROTECTED REGION ID(fbelt.GetRPM) ENABLED START -----#

       	message = 'RPM?' +'\r'
    	DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.ScaleRPM, self.RDBstuffR)

        #----- PROTECTED REGION END -----#	//	fbelt.GetRPM
        return argout
        
    def SetRPM(self, argin):
        """ SetRPM
        :param argin: 
        :type argin: PyTango.DevLong
        :rtype: PyTango.DevString
        """
        self.debug_stream("In SetRPM()")
        argout = ""
        #----- PROTECTED REGION ID(fbelt.SetRPM) ENABLED START -----#

        message = 'PHA:A:' + str(argin) +'\r'
        DimFBEinterf.SendAndGetT([message, '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffR)
        
        #----- PROTECTED REGION END -----#	//	fbelt.SetRPM
        return argout
        
    def GetOneWireID(self):
        """ retrieve one wire temp sensor serial number
        """
        self.debug_stream("In GetOneWireID()")
        #----- PROTECTED REGION ID(fbelt.GetOneWireID) ENABLED START -----#

	message = 'owid?' +'\r'    	
	
	DimFBEinterf.SendAndGetT([message, 'ReadOneWireIDstarted', '*'], [self.IP, self.Port], self.PassThrough, self.RDBstuffOWid)
        
        #----- PROTECTED REGION END -----#	//	fbelt.GetOneWireID
        
    def ApplyDefault(self):
        """ 
        """
        self.debug_stream("In ApplyDefault()")
        #----- PROTECTED REGION ID(fbelt.ApplyDefault) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	fbelt.ApplyDefault
        

    #----- PROTECTED REGION ID(fbelt.programmer_methods) ENABLED START -----#



    
    #----- PROTECTED REGION END -----#	//	fbelt.programmer_methods

class fbeltClass(PyTango.DeviceClass):
    # -------- Add you global class variables here --------------------------
    #----- PROTECTED REGION ID(fbelt.global_class_variables) ENABLED START -----#
    
    #----- PROTECTED REGION END -----#	//	fbelt.global_class_variables


    #    Class Properties
    class_property_list = {
        }


    #    Device Properties
    device_property_list = {
        'DeviceIP':
            [PyTango.DevString, 
             '',
            [] ],
        'DevicePort':
            [PyTango.DevString, 
             '',
            [] ],
        'OneWireID':
            [PyTango.DevString, 
            "One Wire Serial",
            [] ],
        }


    #    Command definitions
    cmd_list = {
        'GetID':
            [[PyTango.DevVoid, "none"],
            [PyTango.DevString, "none"]],
        'GetTemperature':
            [[PyTango.DevVoid, "none"],
            [PyTango.DevFloat, "none"]],
        'GetRPM':
            [[PyTango.DevVoid, "none"],
            [PyTango.DevLong, "none"]],
        'SetRPM':
            [[PyTango.DevLong, "none"],
            [PyTango.DevString, "none"]],
        'GetOneWireID':
            [[PyTango.DevVoid, "none"],
            [PyTango.DevVoid, "none"]],
        'ApplyDefault':
            [[PyTango.DevVoid, "none"],
            [PyTango.DevVoid, "none"]],
        }


    #    Attribute definitions
    attr_list = {
        'Temperature':
            [[PyTango.DevDouble,
            PyTango.SCALAR,
            PyTango.READ]],
        'RPM':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ]],
        'ID':
            [[PyTango.DevString,
            PyTango.SCALAR,
            PyTango.READ]],
        'HorizontalPhase':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'VerticalPhase':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'LongitudinalPhase':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'BackEndPhase':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'HorizontalAttenuation':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'VerticalAttenuation':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'LongitudinalAttenuation':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'BackEndAttenuation':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'IP':
            [[PyTango.DevString,
            PyTango.SCALAR,
            PyTango.READ]],
        'Port':
            [[PyTango.DevString,
            PyTango.SCALAR,
            PyTango.READ]],
        'HorizontalPhaseDeg':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'VerticalPhaseDeg':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'LongitudinalPhaseDeg':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'BackEndPhaseDeg':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'OneWireID':
            [[PyTango.DevString,
            PyTango.SCALAR,
            PyTango.READ]],
        'HorizontalAttenuation_dB':
            [[PyTango.DevDouble,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'VerticalAttenuation_dB':
            [[PyTango.DevDouble,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'BackEndAttenuation_dB':
            [[PyTango.DevDouble,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        'LongitudinalAttenuation_dB':
            [[PyTango.DevDouble,
            PyTango.SCALAR,
            PyTango.READ_WRITE],
            {
                'Memorized':"true_without_hard_applied"
            } ],
        }


def main():
    try:
        py = PyTango.Util(sys.argv)
        py.add_class(fbeltClass, fbelt, 'fbelt')
        #----- PROTECTED REGION ID(fbelt.add_classes) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	fbelt.add_classes

        U = PyTango.Util.instance()
        U.server_init()
        U.server_run()

    except PyTango.DevFailed as e:
        print ('-------> Received a DevFailed exception:', e)
    except Exception as e:
        print ('-------> An unforeseen exception occured....', e)

if __name__ == '__main__':
    main()
